#! /usr/bin/env python3

from sys import argv
from pprint import pprint
import json
import yaml

with open('components.yml', 'r') as fh:
    components = yaml.load(fh, Loader=yaml.SafeLoader)

parts = {}
for d in components.values():
    if 'Partid' in d:
        part = parts.setdefault(
            d['Partid'],
            {
                'Designators': [],
            }
        )
        part['Designators'].append(d['Designator'])
        for key, value in d.items():
            if key not in (
                'Designator',
                'Id',
                'PartId',
            ):
                if key not in part:
                    part[key] = value
                else:
                    if part[key] != value:
                        # print(key, value, part[key])
                        raise ValueError
# pprint(parts)

with open('bom.yml', 'w') as fh:
    yaml.dump(
        parts,
        fh,
        indent=4,
        sort_keys=True,
        encoding='utf8',
        allow_unicode=True
    )
